import { RouteHelper, CoreMenuView } from '../core'

import IdentityPublicCreateUserView from './views/public-create-user/public-create-user-view.vue'
import IdentityPublicEmailVerificationView from './views/public-email-verification/public-email-verification-view.vue'
import IdentityPublicPasswordForgotView from './views/public-password-forgot/public-password-forgot-view.vue'
import IdentityPublicEmailVerificationResendView from './views/public-email-verification-resend/public-email-verification-resend-view.vue'
import IdentityPublicPasswordResetView from './views/public-password-reset/public-password-reset-view.vue'
import IdentityUsersView from './views/users/users-view.vue'
import IdentityUserProfileView from './views/user-profile/user-profile-view.vue'
import IdentityAccountPasswordChangeView from './views/account-password-change/account-password-change-view.vue'
import IdentityAccountEditView from './views/account-edit/account-edit-view.vue'

const components = [
  CoreMenuView,
  IdentityPublicCreateUserView,
  IdentityPublicEmailVerificationView,
  IdentityPublicPasswordForgotView,
  IdentityPublicEmailVerificationResendView,
  IdentityPublicPasswordResetView,
  IdentityUsersView,
  IdentityUserProfileView,
  IdentityAccountPasswordChangeView,
  IdentityAccountEditView,
]

const meta = [
  {
    id: null,
    sortOrder: 2,
    name: 'identity-public-create-user',
    parent: null,
    path: '/account/sign-up',
    title: 'Sign up',
    menuItem: false,
    iconClass: 'bi bi-person-plus-fill',
    component: 'IdentityPublicCreateUserView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 3,
    name: 'identity-public-email-verification',
    parent: null,
    path: '/account/email-verification',
    title: 'Email verification',
    menuItem: false,
    iconClass: 'bi bi-envelope-check',
    component: 'IdentityPublicEmailVerificationView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 4,
    name: 'identity-public-forgot-password',
    parent: null,
    path: '/account/forgot-password',
    title: 'Forgot Password',
    menuItem: false,
    iconClass: 'bi bi-key-fill',
    component: 'IdentityPublicPasswordForgotView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 5,
    name: 'identity-public-resend-email-verification',
    path: '/account/resend-email-verification',
    parent: null,
    title: 'Resend email verification',
    menuItem: false,
    iconClass: 'bi bi-envelope-check',
    component: 'IdentityPublicEmailVerificationResendView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 6,
    name: 'identity-public-password-reset',
    parent: null,
    path: '/account/reset-password',
    title: 'Reset Password',
    menuItem: false,
    iconClass: 'bi bi-key-fill',
    component: 'IdentityPublicPasswordResetView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 7,
    name: 'identity-users',
    parent: null,
    path: '/users',
    title: 'Users',
    menuItem: false,
    iconClass: 'bi bi-people-fill',
    component: 'IdentityUsersView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'identity-user-profile',
    parent: 'identity-users',
    path: '/users/:username',
    title: 'Profile',
    menuItem: false,
    iconClass: 'bi bi-person-circle',
    component: 'IdentityUserProfileView',
    redirect: null,
    requiresAuthentication: false,
    requiredRoles: '',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'identity-account',
    parent: null,
    path: '/account',
    title: 'Account',
    menuItem: false,
    iconClass: 'bi bi-person-fill',
    component: 'CoreMenuView',
    redirect: null,
    requiresAuthentication: true,
    requiredRoles: '1',
  },
  {
    id: null,
    sortOrder: 1,
    name: 'identity-account-password-change',
    parent: 'identity-account',
    path: '/account/change-password',
    title: 'Change password',
    menuItem: true,
    iconClass: 'bi bi-key-fill',
    component: 'IdentityAccountPasswordChangeView',
    redirect: null,
    requiresAuthentication: true,
    requiredRoles: '1',
  },
  {
    id: null,
    sortOrder: 2,
    name: 'identity-account-edit',
    parent: 'identity-account',
    path: '/account/edit',
    title: 'Edit Profile',
    menuItem: true,
    iconClass: 'bi bi-person-circle',
    component: 'IdentityAccountEditView',
    redirect: null,
    requiresAuthentication: true,
    requiredRoles: '1',
  },
  {
    id: null,
    sortOrder: 8,
    name: 'identity-admin',
    parent: null,
    path: '/admin',
    title: 'Admin Menu',
    menuItem: false,
    iconClass: 'bi bi-shield',
    component: 'CoreMenuView',
    redirect: null,
    requiresAuthentication: true,
    requiredRoles: '3',
  },
]

export default meta.map((x) => RouteHelper.metaToRoute(x, components))
